# zbot/plugs/directory.py
#
#

""" mail input plugin. """

## IMPORTS

from zbot.utils import strip_html, j, error
from zbot.generic import need_skip
from zbot import kernel, Object

import email.message
import datetime
import logging
import email
import time
import os

## COMMANDS

def do_dir(event):
    if not event.rest: event.reply("what directory?") ; return
    target = event.rest
    if not os.path.isdir(target): event.reply("%s is not a directory." % target) ; return
    teller = 0
    event.reply("scanning %s" % target)
    for fn in os.listdir(target):
        ff = target + os.sep + fn 
        logging.warn("reading %s" % ff)
        try:
            o = Object()
            data = open(ff, "r").read()
            message = email.message_from_string(data) ; o.update(message.items())
            o.text = ""
            o.filename = ff
            for load in message.get_payload():
                if need_skip(load, ["html", ],): continue
                else: o.text += str(load)
            o.save()
        except IsADirectoryError: continue
        except Exception: error() ; continue
        teller += 1
        logging.warn("at %s" % teller)

kernel.cmnds.register("dir", do_dir)
